﻿unit form1;

interface

uses
  qtx.sysutils,
  qtx.classes,
  qtx.dom.types,
  qtx.dom.events,
  qtx.dom.graphics,
  qtx.dom.widgets,
  qtx.dom.theme,
  qtx.dom.application,
  qtx.dom.forms;

type

  Tform1 = class(TQTXForm)
  protected
    procedure InitializeObject; override;
    procedure FinalizeObject; override;
    procedure StyleObject; override;

    procedure PlayAudio(element: Variant);
  public
    procedure AddElement(AElement: Variant);
  end;

implementation uses qtx.dom.stylesheet, qtx.JSON;


type TServerItem = record server, id, country: string end;

const
 C_Server: Array[0..4] of TServerItem=(
  (server: 'us'; id: 'US'; country: 'United States'),
  (server: 'us'; id: 'MX'; country: 'Mexico'),
  (server: 'ca'; id: 'CA'; country: 'Canada'),
  (server: 'au'; id: 'AU'; country: 'Australia'),
  (server: 'nz'; id: 'NZ'; country: 'New Zealand'));

procedure Tform1.InitializeObject;
begin
  inherited;
  style.margin:='0';
  style.padding:='0';
  style.height:='100%';
  style.fontFamily := '"Source Sans Pro", sans-serif';
  style.color:= '#fff';
  style.textShadow := '1px 0 0 #242738';
  style.backgroundColor := '#333';
  style.overflow := 'scroll';

  self.InnerHtml:=#'
    <div class="wrapper">
            <div class="header"></div>
            <div class="main">
              <div class="main__sidebar-left">
                <div class="sidebar-menu">
                  <div class="sidebar-menu__header">Main</div>
                  <ul class="sidebar-menu__list">
                    <li class="sidebar-menu__items active"><a class="sidebar-menu__link" href="#"><i class="fa fa-list-alt"></i> Browse</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-bell"></i> Activity</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-music"></i> Radio</a></li>
                  </ul>
                </div>
                <div class="sidebar-menu">
                  <div class="sidebar-menu__header">Your music</div>
                  <ul class="sidebar-menu__list">
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-music"></i> Songs</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-circle-o"></i> Albums</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-microphone"></i> Artists</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-music"></i> Stations</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-file-audio-o"></i> Local Files</a></li>
                  </ul>
                </div>
                <div class="sidebar-menu">
                  <div class="sidebar-menu__header">Playlists</div>
                  <ul class="sidebar-menu__list">
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-music"></i> AYM</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-music"></i> Kabali</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-music"></i> Workout</a></li>
                    <li class="sidebar-menu__items"><a class="sidebar-menu__link" href="#"><i class="fa fa-music"></i> Civil war</a></li>
                  </ul>
                </div>
              </div>
              <div class="main__content">
                <div class="content-title">Browse</div>
                <div class="content-menu">
                  <ul class="content-menu__list">
                    <li class="content-menu__item active"><a class="content-menu__link" href="#">Overview</a></li>
                    <li class="content-menu__item"><a class="content-menu__link" href="#">Charts</a></li>
                    <li class="content-menu__item"><a class="content-menu__link" href="#">Genres & Moods</a></li>
                    <li class="content-menu__item"><a class="content-menu__link" href="#">New Releases</a></li>
                    <li class="content-menu__item"><a class="content-menu__link" href="#">Discover</a></li>
                    <li class="content-menu__item"><a class="content-menu__link" href="#">Concerts</a></li>
                  </ul>
                </div>
                <div class="playlist">
                  <div class="playlist__header">
                    <div class="playlist__header-title">Radio stations just for you</div>
                    <div class="playlist__header-nav"><a class="header-nav__link header-nav__link_disable" href="#"><i class="fa fa-angle-left"></i></a><a class="header-nav__link" href="#"><i class="fa fa-angle-right"></i></a></div>
                  </div>
                  <ul class="playlist__list">
                  </ul>
                </div>
              </div>
              <div class="main__sidebar-right">
                <div class="friends">
                  <ul class="friends__list">
                    <li class="friends__items">
                      <div class="friends__img"><img src="https://pbs.twimg.com/profile_images/645448506530906112/GTZEmESS.png" alt="Paty Spivot"/></div>
                      <div class="friends__name">Paty Spivot</div>
                    </li>
                    <li class="friends__items online">
                      <div class="friends__img"><img src="https://pbs.twimg.com/profile_images/729799803262111744/u8uGsxx3.jpg" alt="Thea Queen"/></div>
                      <div class="friends__name">Thea Queen</div>
                    </li>
                    <li class="friends__items">
                      <div class="friends__img"><img src="https://upload.wikimedia.org/wikipedia/en/thumb/5/54/John_MacClane.jpg/220px-John_MacClane.jpg" alt="John MCClane"/></div>
                      <div class="friends__name">John MCClane</div>
                    </li>
                    <li class="friends__items">
                      <div class="friends__img"><img src="https://65.media.tumblr.com/avatar_cbc5bc1afc99_128.png" alt="Logan"/></div>
                      <div class="friends__name">Logan</div>
                    </li>
                  </ul>
                </div><a class="add-fiends" href="#">Add Friends</a>
              </div>
            </div>
            <div class="footer">
              <div class="player">
                <div class="player__control"><a class="control__link" href="#"><i class="fa fa-step-backward"></i></a><a class="control__link play" href="#"><i class="fa fa-play"></i></a><a class="control__link" href="#"><i class="fa fa-step-forward"></i></a></div>
                <div class="player__time">00:59</div>
                <div class="player__line">
                  <div class="player__line-inner"></div>
                </div>
                <div class="player__time">4:11</div>
                <div class="player__control"><a class="control__link" href="#"><i class="fa fa-list-ul"></i></a><a class="control__link" href="#"><i class="fa fa-reply-all"></i></a><a class="control__link" href="#"><i class="fa fa-retweet"></i></a><a class="control__link" href="#"><i class="fa fa-volume-up"></i>
                    <div class="volume-line">
                      <div class="volume-line__inner"></div>
                    </div></a></div>
              </div>
            </div>
          </div>';

   var lIndex := 0;
   TQTXWebLoader.FetchText(format('https://%s.api.iheart.com/api/v2/content/liveStations?countryCode=%s&limit=10000',
      [C_SERVER[lIndex].server, C_SERVER[lIndex].id]),
     procedure (Url: string; Response: string; Error: Exception)
     begin
      if Error = nil then
      begin
       var LRadioList = JSon.Parse(Response);
       var hits = LRadioList['hits'];
       for var x := 0 to hits.length-1  do
         AddElement(hits[x]);
      end
      else
       raise Error;
      end);
end;

function Get(AValue: Variant;AProperty: String): String;
begin
 if AValue.hasOwnProperty(AProperty) then
  result := AValue[AProperty]
 else
  result := '';
end;

procedure Tform1.playAudio(element: Variant);
begin
 var url := Get(element['streams'],'shoutcast_stream');
 if url = '' then
  url := Get(element['streams'],'hls_stream');

  asm
   var audio = document.getElementById("RadioPlayer");
   if ( audio != null) {
    audio.remove()
   }

   audio = document.createElement("audio");
   audio.id = "RadioPlayer";
   audio.autoplay = true;
   var source = document.createElement("source");
   source.type = "audio/mpeg";
   source.src = @url;
   audio.appendChild(source);
   document.body.appendChild(audio);
  end;

end;

procedure Tform1.AddElement(AElement: Variant);

 procedure intPlayAudio(audioElement: Variant);
 begin
  PlayAudio(audioElement);
 end;

begin
 asm
  var audioElem = @AElement;

  var playlistItems = document.querySelector('.playlist__list');
  var newListItem = document.createElement('li');
  newListItem.classList.add('playlist__items');

  var playLink = document.createElement('a');
  playLink.classList.add('song-btn__link', 'play');
  playLink.innerHTML = '<i class="fa fa-play"></i>';
  playLink.addEventListener('click', function() {
     var audioElem = JSON.parse(unescape(this.getAttribute('data')));
     @intPlayAudio(audioElem);
  });

  playLink.setAttribute('data', escape(JSON.stringify(audioElem)));

  newListItem.innerHTML =
    ' <div class="playlist__song">' +
    '   <div class="playlist__song-cover"><img src="' + audioElem.logo + '" alt="Alt"/></div>' +
    '   <div class="playlist__song-btn">' +
    '     <div class="song-btn">' +
    '       <a class="song-btn__link" href="#"><i class="fa fa-plus"></i></a>' +
    '     </div>' +
    '   </div>' +
    ' </div>' +
    ' <div class="playlist__song-title">' + audioElem.name + '</div>';

  newListItem.querySelector('.song-btn').appendChild(playLink);
  playlistItems.appendChild(newListItem);
 end;
end;

procedure Tform1.FinalizeObject;
begin
  inherited;
end;

procedure Tform1.StyleObject;
begin
  inherited;
  PositionMode := TQTXWidgetPositionMode.cpInitial;
  DisplayMode := TQTXWidgetDisplayMode.cdBlock;
end;



initialization
begin
  var lSheet := TQTXCSSRules.Global;
  lSheet.AddStyles(#'
    @import "https://fonts.googleapis.com/css?family=Source+Sans+Pro:200,300,400,700";
     * {
         box-sizing: border-box;
    }
     ul, li {
         margin: 0;
         padding: 0;
         list-style-type: none;
    }
     .wrapper {
         display: flex;
         min-width: 500px;
         min-height: 100vh;
         flex-direction: column;
    }
     .header {
         height: 50px;
         border-bottom: 1px solid #313342;
         min-width: 500px;
    }
     .main {
         display: flex;
         flex-direction: row;
         flex-wrap: nowrap;
         justify-content: flex-start;
         align-content: stretch;
         align-items: stretch;
         flex: 1;
    }
     .main__content {
         min-width: 600px;
         flex-grow: 1;
    }
     .main__sidebar-left {
         min-width: 170px;
         order: 0;
         flex: 0 1 170px;
         align-self: auto;
         border-right: 1px solid #313342;
    }
     .main__sidebar-right {
         min-width: 230px;
         order: 0;
         flex: 0 1 230px;
         align-self: auto;
         border-left: 1px solid #313342;
    }
     .sidebar-menu {
         margin-top: 30px;
    }
     .sidebar-menu__header {
         margin-left: 20px;
         margin-bottom: 15px;
         text-transform: uppercase;
    }
     .sidebar-menu__items {
         border-left: 5px solid transparent;
         transition: all 0.3s;
    }
     .sidebar-menu__link {
         display: block;
         margin-bottom: 5px;
         margin-left: 15px;
         padding: 5px 0;
         text-decoration: none;
         opacity: 0.5;
         color: #fff;
         transition: all 0.3s;
    }
     .sidebar-menu__link i {
         margin-right: 10px;
    }
     .sidebar-menu__items.active {
         border-left: 5px solid #089680;
    }
     .sidebar-menu__items:hover .sidebar-menu__link, .sidebar-menu__items.active .sidebar-menu__link {
         opacity: 1;
    }
     .content-title {
         margin: 50px;
         font-size: 48px;
         font-weight: 200;
         margin-bottom: 20px;
    }
     .content-menu {
         padding-left: 50px;
         border-bottom: 1px solid #313342;
    }
     .content-menu__item {
         display: inline-block;
    }
     .content-menu__link {
         position: relative;
         display: block;
         color: #fff;
         text-decoration: none;
         text-transform: uppercase;
         margin-right: 30px;
         padding-bottom: 15px;
         opacity: 0.5;
         transition: all 0.3s;
    }
     .content-menu__link:after {
         position: absolute;
         content: "";
         display: block;
         bottom: -3px;
         left: 0;
         width: 100%;
         height: 5px;
         border-radius: 2px;
         background-color: transparent;
    }
     .content-menu__link:hover {
         opacity: 1;
    }
     .content-menu__item.active .content-menu__link {
         opacity: 1;
    }
     .content-menu__item.active .content-menu__link:after {
         background-color: #089680;
    }
     .friends {
         display: flex;
         margin: 30px;
    }
     .friends__items {
         display: flex;
         align-items: center;
         margin-bottom: 10px;
    }
     .friends__items:hover {
         cursor: pointer;
         color: #c5c5c5;
    }
     .friends__img {
         position: relative;
         width: 50px;
         height: 50px;
         margin-right: 10px;
    }
     .friends__img img {
         border-radius: 50%;
         height: 100%;
         position: absolute;
         margin: auto;
         top: 0;
         left: 0;
         right: 0;
         bottom: 0;
    }
     .friends__items.online .friends__img:after {
         content: "";
         position: absolute;
         top: 5px;
         right: 0px;
         width: 10px;
         height: 10px;
         border-radius: 50%;
         background-color: #089680;
    }
     .add-fiends {
         display: block;
         color: #fff;
         text-decoration: none;
         font-size: 18px;
         display: flex;
         justify-content: center;
         background-color: #089680;
         padding: 10px 0;
         border-radius: 20px;
         margin: 0 30px;
         text-shadow: none;
    }
     .footer {
         height: 80px;
         border-top: 1px solid #313342;
         display: flex;
         position: fixed;
         bottom: 0;
         left: 0;
         right: 0;
    }
     .player {
         display: flex;
         width: 100%;
         align-items: center;
         margin-left: 20px;
    }
     .player__control {
         display: flex;
         align-items: center;
    }
     .player__line {
         flex: 1;
         width: 400px;
         height: 5px;
         border-radius: 5px;
         background-color: #5d6373;
    }
     .player__line-inner {
         width: 28%;
         height: 5px;
         border-radius: 5px;
         background-color: #089680;
    }
     .player__time {
         margin: 0 15px;
    }
     .control__link {
         color: #fff;
         margin-right: 20px;
         text-decoration: none;
         display: flex;
         align-items: center;
    }
     .control__link:hover {
         color: #089680;
    }
     .play {
         display: flex;
         align-items: center;
         justify-content: center;
         width: 40px;
         height: 40px;
         border-radius: 50%;
         border: 2px solid #089680;
    }
     .volume-line {
         margin-left: 10px;
         width: 70px;
         height: 5px;
         border-radius: 5px;
         background-color: #5d6373;
    }
     .volume-line__inner {
         width: 68%;
         height: 5px;
         border-radius: 5px;
         background-color: #089680;
    }
     .playlist {
         margin: 50px;
    }
     .playlist__header {
         display: flex;
         align-items: center;
         margin-bottom: 20px;
    }
     .playlist__header-title {
         flex: 1;
         font-size: 18px;
    }
     .playlist__list {
         display: flex;
         flex-wrap: wrap;
         justify-content: flex-start;
    }
     .playlist__items {
         margin-right: 30px;
         margin-bottom: 20px;
    }
     .playlist__items:nth-child(3n) {
         margin-right: 0;
    }
     .playlist__song {
         position: relative;
         overflow: hidden;
         border-radius: 5px;
         box-shadow: 0px 36px 47px -27px rgba(0, 0, 0, 0.62);
    }
     .playlist__song-cover {
         position: relative;
         width: 230px;
         height: 230px;
    }
     .playlist__song-cover img {
         width: 100%;
         position: absolute;
         margin: auto;
         top: 0;
         left: 0;
         right: 0;
         bottom: 0;
    }
     .playlist__song-btn {
         display: none;
         position: absolute;
         top: 0;
         left: 0;
         right: 0;
         bottom: 0;
         background: rgba(0, 0, 0, 0.5);
    }
     .playlist__song-title {
         font-weight: 300;
         margin-top: 10px;
    }
     .song-btn {
         display: flex;
         justify-content: center;
         height: 100%;
         align-items: center;
    }
     .song-btn__link {
         color: #fff;
         text-decoration: none;
         margin: 0 5px;
    }
     .song-btn__link:hover {
         color: #089680;
    }
     .playlist__song:hover .playlist__song-btn {
         display: block;
    }
     .header-nav__link {
         color: #fff;
         margin-left: 20px;
         font-size: 24px;
    }
     .header-nav__link_disable {
         color: #5d6373;
         cursor: default;
    }
  ');
end;

end.
